;
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
; Headerdatei
;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
;Der ATmega8 laeuft mit 1,8418432 MHz und wird an 5V betrieben.
;
;Es soll der Fehler gefunden werden, warum nicht in die TWI-Interrupt-Service-
;Routine gesprungen wird bzw. warum im ATMEL-Studio7 nicht das TWINT-Bit im
;TWCR gesetzt wird und somit natrlich nicht in die TWI-ISR gesprungen wird.
;
;CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
; Einbinden der Controllerspezifischen Definitionsdatei
;CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
;
.NOLIST                 ;List-Output ausschalten
.INCLUDE "m8def.inc"    ;AVR-Definitionsdatei einbinden
.LIST                   ;List-Output wieder einschalten
;
;RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
;RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
; Arbeitsregister umbenennen
;RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
;RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
;
.DEF ovf0_zaehler	  = r11		;Timer0 Overflow-Zaehler


.DEF s_sreg           = r15     ;Zum Sichern des Statusregisters ( Nur 1 Takt )

.DEF a       = r16      ;Arbeitsregister Low- Byte
.DEF b       = r17      ;Arbeitsregister High-Byte

.DEF flag_reg    = r19       ;Allgemeines Flaggenregister


.DEF key_reg = r21       ;Fuer die Tasterentprellung
.DEF ia       = r22     ;Interrupt Arbeitsregister a ( Nur in ISR genutzt )
.DEF ib       = r23     ;Interrupt Arbeitsregister b ( Nur in ISR genutzt )
;
;KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
;KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
; Konstanten als Symbole
;KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
;KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
;
.EQU #ovf0_zaehler	= 4			;Wert f. Timer0 Overflowzaehler

 
.EQU #twbr			= 2			;Wert f. TWI SCL-Frequenz 
.EQU #twi_start		= 1<<TWINT|1<<TWSTA|1<<TWEN|1<<TWIE	    ;TWI-START-Bedingung
.EQU #rm_twi_start	= $08		;Rueckmeldung. Das Startsignal wurde gesendet
;
;
;Bitbezeichner fuer das allgemeine Flaggenregister flag_reg
;
;.equ			= 0	;
;.equ			= 1	;
;.equ			= 2	;
;.equ			= 3	;
.equ	pla.flg		= 4	;Programmlaufanzeige-Flagge
;.equ		= 5	;
.equ	new.char	= 6	; Neues Zeichen
;.equ		= 7	; 
;
;Bitbezeichner fuer das Tasterentprellregister key_reg
;
;.equ			= 0	;
;.equ			= 1	;
.equ  key.unactuated	= 2	;Taster entprellt unbetaetigt
.equ  key.actuated		= 3	;Taster entprellt betaetigt
;.equ			= 4	;
;.equ	= 5	;
;.equ	= 6	; 
;.equ		= 7	; 